#include "Plugin.h"
#include "PluginMenu.h"
#include "FriendsManager.h"

// Message hook
#if MESSAGEHOOK_ENABLED
	BOOL Plugin::MessageHook(PluginAPI::ConnectionInterface Connection,
							 BYTE MessageId, LPCVOID MessageData, DWORD MessageSize)
	{
		if (Connection == PluginAPI::Connection_BNCS) {
			switch(MessageId) {
			case 0x0a:
				{
					/* enter chat */
					strcpy(lpszMyName, ((char *)MessageData));
					enteredchat = true;

					//if(FriendsMgrWindow)
						/* would requestfriendslist here, but sbv3 does */
				}
				break;
			case 0x65:
				{
					/* list of all friends */
					BYTE NumFriends = ((LPBYTE)MessageData)[0];
					purgefriendslist();
					int pos = 1;
					for (int j = 1; j <= NumFriends; j++) {
						LPSTR lpszName = ((char *)MessageData)+pos;
						pos += strlen(lpszName)+1;
						BYTE status = ((LPBYTE)MessageData)[pos];
						BYTE locationcode = ((LPBYTE)MessageData)[pos+1];
						DWORD product =  _byteswap_ulong (*(PDWORD) (((PBYTE)MessageData)+pos+2));
						LPSTR lpszLocation = ((char *)MessageData)+pos+6;
						//showtext(PluginAPI::Yellow, "friend list! name: %s, locationcode: %u, status: %u, product: %.4s, location: %s\r\n", lpszName, locationcode, status, &product, lpszLocation);
						Friendslist *currentuser = 0;
						myfriends->rewind();
						currentuser = new Friendslist();
						currentuser->UpdateFriendslist(lpszName, j-1, status, locationcode, product, lpszLocation);
						myfriends->add(currentuser);
						pos += 6+strlen(lpszLocation)+1;
					}
					if(FriendsMgrWindow)
						buildfriendslist();
					return TRUE;
				}
				break;
			case 0x66:
				{
					/* friend update */
					BYTE EntryNumber = ((LPBYTE)MessageData)[0];
					BYTE status = ((LPBYTE)MessageData)[1];
					BYTE locationcode = ((LPBYTE)MessageData)[2];
					DWORD product =  _byteswap_ulong (*(PDWORD) (((PBYTE)MessageData)+3));
					LPSTR lpszLocation = ((char *)MessageData)+7;
					//showtext(PluginAPI::Yellow, "friend update! entry: %u, locationcode: %u, status: %u, product: %.4s, location: %s\r\n", EntryNumber, locationcode, status, &product, lpszLocation);
					
					char getname[64] = "";
					Friendslist *currentuser = 0;
					myfriends->rewind();
					while(!myfriends->at_end()) {
						currentuser = myfriends->get();
						if(currentuser->GetFriendNum() == EntryNumber) {
							currentuser->GetName(getname);
							currentuser->UpdateFriendslist(getname, EntryNumber, status, locationcode, product, lpszLocation);
							if(FriendsMgrWindow)
								ModifyFriendOnlinestatus(getname, status, locationcode);
						}
						++*myfriends;
					}
				}
				break;
			case 0x67:
				{
					/* friend add */
					LPSTR lpszName = ((char *)MessageData);
					BYTE status = ((LPBYTE)MessageData)[strlen(lpszName)+1];
					BYTE locationcode = ((LPBYTE)MessageData)[strlen(lpszName)+2];
					DWORD product =  _byteswap_ulong (*(PDWORD) (((PBYTE)MessageData)+strlen(lpszName)+3));
					LPCSTR lpszLocation= ((char *)MessageData)+strlen(lpszName)+7;
					//showtext(PluginAPI::Yellow, "friend add! name: %s, locationcode: %u, status: %u, product: %.4s, location: %s\r\n", lpszName, locationcode, status, &product, lpszLocation);

					Friendslist *currentuser = 0;
					myfriends->rewind();
					currentuser = new Friendslist();
					currentuser->UpdateFriendslist(lpszName, myfriends->get_count(), status, locationcode, product, lpszLocation);
					myfriends->add(currentuser);
					if(FriendsMgrWindow)
						InsertItem(lpszName, status, locationcode);
				}
				break;
			case 0x68:
				{
					/* friend remove */
					BYTE EntryNumber = ((LPBYTE)MessageData)[0];
					//showtext(PluginAPI::Yellow, "friend remove! entry: %u\r\n", EntryNumber);

					char getname[64] = "";
					Friendslist *currentuser = 0;
					myfriends->rewind();
					while(!myfriends->at_end()) {
						currentuser = myfriends->get();
						if(currentuser->GetFriendNum() == EntryNumber) {
							/* remove item from list */
							if(FriendsMgrWindow) {
								currentuser->GetName(getname);
								RemoveItem(getname);
							}
							myfriends->remove(currentuser);
						}
						else {
							if(currentuser->GetFriendNum() > EntryNumber)
								currentuser->UpdateFriendNum(currentuser->GetFriendNum()-1);
							++*myfriends;
						}
					}
				}
				break;
			case 0x69:
				{
					/* friend position update */
					BYTE oldpos = ((LPBYTE)MessageData)[0];
					BYTE newpos = ((LPBYTE)MessageData)[1];
					//showtext(PluginAPI::Yellow, "friend position update! oldpos: %u, newpos: %u\r\n", oldpos, newpos);
					
					char getname[64] = "";
					Friendslist *currentuser = 0;
					myfriends->rewind();
					while(!myfriends->at_end()) {
						currentuser = myfriends->get();
						if(currentuser->GetFriendNum() == oldpos) {
							currentuser->UpdateFriendNum(newpos);
							if(FriendsMgrWindow) {
								currentuser->GetName(getname);
								ModifyItem(getname, currentuser->GetStatus(), currentuser->GetLocationCode(), newpos);
							}
						}
						else if(currentuser->GetFriendNum() == newpos)
							currentuser->UpdateFriendNum(oldpos);
						++*myfriends;
					}
				}
				break;
			}
		}
		return FALSE;
	}
#endif

// Connection hook
#if CONNECTIONHOOK_ENABLED
	BOOL Plugin::ConnectionHook(PluginAPI::ConnectionInterface Connection,
								PluginAPI::ConnectionState EventCode, DWORDLONG PlatformId)
	{
		// Add code here
		if (Connection == PluginAPI::Connection_BNCS && EventCode == PluginAPI::Connection_Closed) {
			/* reset everything */
			strcpy(lpszMyName, "");
			enteredchat = false;
			resetfriendsdata();
		}
		return FALSE;
	}
#endif

// Plugin timer
#if PLUGINTIMER_ENABLED
	DWORD Plugin::PluginTimer(DWORD TimeDelay)
	{
		// Add code here
		return TimeDelay;
	}
#endif

// Command hook
#if COMMANDHOOK_ENABLED
	BOOL Plugin::CommandHook(LPCSTR Message, LPCSTR SendingUser, BOOL FromTelnet)
	{
		// Add code here
		return FALSE;
	}
#endif

// Event hook
#if EVENTHOOK_ENABLED
	BOOL Plugin::EventHook()
	{
		// Add code here
		return FALSE;
	}
#endif

// Enum channel callback
BOOL Plugin::EnumChannelHook(LPCSTR UniqueName, LPCSTR Statstring, DWORD Flags, DWORD Ping,
							 BOOL Invisible, DWORD AccountNumber, DWORD RegAuthority)
{
	// Add code here
	return TRUE;
}

#if HIGHEST_REVISION >= 4
	// Enum filter callbacks
	BOOL Plugin::EnumUserFiltersHook(LPCSTR Filter)
	{
		// Add code here
		return TRUE;
	}

	BOOL Plugin::EnumMessageFiltersHook(LPCSTR Filter)
	{
		// Add code here
		return TRUE;
	}

	// Enum plugins callback
	BOOL Plugin::EnumLoadedPluginsHook(HINSTANCE PluginInst)
	{
		// Add code here
		return TRUE;
	}
#endif

BOOL Plugin::Initialize()
{
	myfriends = new List <Friendslist *>;
	MainMenu = API.GetMenu(PluginAPI::MainWindowMenu);
	AddPluginMenuItem(MainMenu, "Friends Manager...", &MenuId);
	MainWindow = API.GetWindow(PluginAPI::MainWindow);
	WindowHook = SetWindowsHookEx(WH_GETMESSAGE, &GetMessageHook, 0, GetWindowThreadProcessId(MainWindow, 0));
	strcpy(lpszMyName, "");
	return TRUE;
}

void Plugin::Terminate()
{
	if (FriendsMgrWindow)
		DestroyWindow(FriendsMgrWindow);
	UnhookWindowsHookEx(WindowHook);
	RemovePluginMenuItem(MainMenu, MenuId);
	delete myfriends;
}
